'use strict';

var _objectWithoutProperties = require('babel-runtime/helpers/object-without-properties')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _Number$isSafeInteger = require('babel-runtime/core-js/number/is-safe-integer')['default'];

var _getIterator = require('babel-runtime/core-js/get-iterator')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _JSONNestedNode = require('./JSONNestedNode');

var _JSONNestedNode2 = _interopRequireDefault(_JSONNestedNode);

var _grabNode = require('./grab-node');

var _grabNode2 = _interopRequireDefault(_grabNode);

// Returns the "n Items" string for this node, generating and caching it if it hasn't been created yet.
function renderItemString(_ref3) {
  var data = _ref3.data;
  var getItemString = _ref3.getItemString;
  var itemString = _ref3.itemString;
  var itemType = _ref3.itemType;

  if (!itemString) {
    var count = 0;
    if (_Number$isSafeInteger(data.size)) {
      count = data.size;
    } else {
      for (var _iterator = data, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _getIterator(_iterator);;) {
        var _ref;

        if (_isArray) {
          if (_i >= _iterator.length) break;
          _ref = _iterator[_i++];
        } else {
          _i = _iterator.next();
          if (_i.done) break;
          _ref = _i.value;
        }

        var entry = _ref;
        // eslint-disable-line no-unused-vars
        count += 1;
      }
    }
    itemString = count + ' entr' + (count !== 1 ? 'ies' : 'y');
  }
  return getItemString('Iterable', data, itemType, itemString);
}

// Returns the child nodes for each entry in iterable.
// If we have generated them previously we return from cache; otherwise we create them.
function getChildNodes(_ref4) {
  var data = _ref4.data;
  var getItemString = _ref4.getItemString;
  var labelRenderer = _ref4.labelRenderer;
  var previousData = _ref4.previousData;
  var styles = _ref4.styles;
  var theme = _ref4.theme;
  var valueRenderer = _ref4.valueRenderer;

  var childNodes = [];
  for (var _iterator2 = data, _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : _getIterator(_iterator2);;) {
    var _ref2;

    if (_isArray2) {
      if (_i2 >= _iterator2.length) break;
      _ref2 = _iterator2[_i2++];
    } else {
      _i2 = _iterator2.next();
      if (_i2.done) break;
      _ref2 = _i2.value;
    }

    var entry = _ref2;

    var key = null;
    var value = null;
    if (Array.isArray(entry)) {
      key = entry[0];
      value = entry[1];
    } else {
      key = childNodes.length;
      value = entry;
    }

    var previousDataValue = undefined;
    if (typeof previousData !== 'undefined' && previousData !== null) {
      previousDataValue = previousData[key];
    }

    var node = _grabNode2['default']({
      getItemString: getItemString,
      key: key,
      labelRenderer: labelRenderer,
      previousData: previousDataValue,
      styles: styles,
      theme: theme,
      value: value,
      valueRenderer: valueRenderer
    });

    if (node !== false) {
      childNodes.push(node);
    }
  }

  return childNodes;
}

// Configures <JSONNestedNode> to render an iterable

exports['default'] = function (_ref5) {
  var props = _objectWithoutProperties(_ref5, []);

  return _react2['default'].createElement(_JSONNestedNode2['default'], _extends({}, props, {
    getChildNodes: getChildNodes,
    nodeType: 'Iterable',
    nodeTypeIndicator: '()',
    renderItemString: renderItemString
  }));
};

module.exports = exports['default'];